package com.gic.store.service.impl;

import com.gic.store.constant.StoreOwnerFlagEnum;
import com.gic.store.dao.mapper.TabStoreRegionRelMapper;
import com.gic.store.entity.TabStoreRegionRel;
import com.gic.store.service.StoreRegionRelService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;

/**
 *
 * @Description:
 * @author zhiwj
 * @date 2019-09-23 14:07
 */
@Service
public class StoreRegionRelServiceImpl implements StoreRegionRelService {

    @Autowired
    private TabStoreRegionRelMapper tabStoreRegionRelMapper;

    @Override
    public Integer saveByOwner(Integer enterpriseId, Integer regionId) {
        TabStoreRegionRel storeRegionRel = new TabStoreRegionRel();
        storeRegionRel.setRegionId(regionId);
        storeRegionRel.setEnterpriseId(enterpriseId);
        storeRegionRel.setFromEnterpriseId(enterpriseId);
        storeRegionRel.setOwnerFlag(StoreOwnerFlagEnum.OWNER.getCode());
        storeRegionRel.setDeleteFlag(0);
        storeRegionRel.setCreateTime(new Date());
        return tabStoreRegionRelMapper.insertSelective(storeRegionRel);
    }

    @Override
    public Integer saveByOther(Integer fromEnterpriseId, Integer enterpriseId, Integer regionId) {
        TabStoreRegionRel storeRegionRel = new TabStoreRegionRel();
        storeRegionRel.setRegionId(regionId);
        storeRegionRel.setFromEnterpriseId(fromEnterpriseId);
        storeRegionRel.setEnterpriseId(enterpriseId);
        storeRegionRel.setOwnerFlag(StoreOwnerFlagEnum.OTHER.getCode());
        storeRegionRel.setDeleteFlag(0);
        storeRegionRel.setCreateTime(new Date());
        return tabStoreRegionRelMapper.insertSelective(storeRegionRel);
    }

    @Override
    public boolean validIsOwn(Integer enterpriseId, Integer regionId) {
        TabStoreRegionRel param = new TabStoreRegionRel();
        param.setEnterpriseId(enterpriseId);
        param.setRegionId(regionId);
        TabStoreRegionRel storeRegionRel = tabStoreRegionRelMapper.get(param);
        return storeRegionRel != null && StoreOwnerFlagEnum.OWNER.getCode() == storeRegionRel.getOwnerFlag();
    }

    @Override
    public List<Integer> listByAuthorize(Integer fromEnterpriseId, Integer toEnterpriseId) {
        // fromEnterpriseId
        return tabStoreRegionRelMapper.listByAuthorize(fromEnterpriseId, toEnterpriseId);
    }

    @Override
    public void delByRegionIds(Integer enterpriseId, List<Integer> delRelList, Integer ownerFlag) {
        tabStoreRegionRelMapper.delByRegionIds(enterpriseId, delRelList, ownerFlag);
    }

    @Override
    public TabStoreRegionRel getByRegionIdAndEnterpriseId(Integer regionId, Integer enterpriseId, int ownerFlag) {
        TabStoreRegionRel storeRegionRel = new TabStoreRegionRel();
        storeRegionRel.setRegionId(regionId);
        storeRegionRel.setEnterpriseId(enterpriseId);
        storeRegionRel.setOwnerFlag(ownerFlag);
        return tabStoreRegionRelMapper.getByRegionIdAndEnterpriseId(storeRegionRel);
    }

    @Override
    public void updateStatusByOther(Integer enterpriseId, Integer regionId, int status) {
        tabStoreRegionRelMapper.updateStatusByOther(enterpriseId, regionId, status);
    }

    @Override
    public int cancelRegionAuth(Integer ownEnterpriseId, Integer unionEnterpriseId) {
        return tabStoreRegionRelMapper.cancelRegionAuth(ownEnterpriseId, unionEnterpriseId);
    }
}
